<?php
// Autorise toutes les origines à accéder à cette ressource (à utiliser avec précaution)
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Content-Type");

// Connexion à la base de données
$servername = "localhost";
$username = "visanffr_regroupment";
$password = "TimianlQbS=H";
$dbname = "visanffr_regroupment";

$conn = new mysqli($servername, $username, $password, $dbname);

// Vérifier la connexion
if ($conn->connect_error) {
    die("Connexion échouée: " . $conn->connect_error);
}

// Vérifier si la requête est POST
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    // Récupérer l'action demandée (ajouter, mettre à jour, supprimer)
    $action = isset($_POST['action']) ? $_POST['action'] : '';
    
    // Variables communes
    $id = isset($_POST['id']) ? $_POST['id'] : null; // Utilisé pour la mise à jour et la suppression
    $nom = isset($_POST['nom']) ? $_POST['nom'] : '';
    $prenom = isset($_POST['prenom']) ? $_POST['prenom'] : '';
    $naissance = isset($_POST['naissance']) ? $_POST['naissance'] : '';
    $code = isset($_POST['code']) ? $_POST['code'] : '';
    $date_delevrance = isset($_POST['date_delevrance']) ? $_POST['date_delevrance'] : '';
    $date_expiration = isset($_POST['date_expiration']) ? $_POST['date_expiration'] : '';
    $photo = isset($_POST['photo']) ? $_POST['photo'] : '';

    // AJOUTER un utilisateur
    if ($action == 'ajouter') {
        // Vérifier si le code existe déjà
        $sql_check = "SELECT * FROM users WHERE code = ?";
        $stmt_check = $conn->prepare($sql_check);
        $stmt_check->bind_param("s", $code);
        $stmt_check->execute();
        $result_check = $stmt_check->get_result();

        if ($result_check->num_rows > 0) {
            // Si le code existe déjà, envoyer un message d'erreur
            echo json_encode(['status' => 'error', 'message' => 'Le code existe déjà']);
        } else {
            // Si le code n'existe pas, insérer les nouvelles données
            $sql_insert = "INSERT INTO users (nom, prenom, naissance, code, date_delevrance, date_expiration, photo) VALUES (?, ?, ?, ?, ?, ?, ?)";
            $stmt_insert = $conn->prepare($sql_insert);
            $stmt_insert->bind_param("sssssss", $nom, $prenom, $naissance, $code, $date_delevrance, $date_expiration, $photo);

            if ($stmt_insert->execute()) {
                echo json_encode(['status' => 'success', 'message' => 'Utilisateur ajouté avec succès']);
            } else {
                echo json_encode(['status' => 'error', 'message' => 'Erreur lors de l\'ajout de l\'utilisateur']);
            }
            $stmt_insert->close();
        }
        $stmt_check->close();
    }

    // METTRE À JOUR un utilisateur
    elseif ($action == 'mettre_a_jour' && !empty($id)) {
        // Vérifier si l'ID existe
        $sql_check_id = "SELECT * FROM users WHERE id = ?";
        $stmt_check_id = $conn->prepare($sql_check_id);
        $stmt_check_id->bind_param("i", $id);
        $stmt_check_id->execute();
        $result_check_id = $stmt_check_id->get_result();

        if ($result_check_id->num_rows == 0) {
            // Si l'ID n'existe pas, envoyer un message d'erreur
            echo json_encode(['status' => 'error', 'message' => 'ID n\'existe pas']);
        } else {
            // Créer un tableau pour stocker les champs à mettre à jour
            $updates = [];
            $params = [];
            $types = '';

            // Vérifier si chaque champ est présent dans la requête et l'ajouter à la mise à jour
            if (!empty($_POST['nom'])) {
                $updates[] = "nom = ?";
                $params[] = $_POST['nom'];
                $types .= 's'; // Type string pour le paramètre
            }
            if (!empty($_POST['prenom'])) {
                $updates[] = "prenom = ?";
                $params[] = $_POST['prenom'];
                $types .= 's';
            }
            if (!empty($_POST['naissance'])) {
                $updates[] = "naissance = ?";
                $params[] = $_POST['naissance'];
                $types .= 's';
            }
            if (!empty($_POST['code'])) {
                $updates[] = "code = ?";
                $params[] = $_POST['code'];
                $types .= 's';
            }
            if (!empty($_POST['date_delevrance'])) {
                $updates[] = "date_delevrance = ?";
                $params[] = $_POST['date_delevrance'];
                $types .= 's';
            }
            if (!empty($_POST['date_expiration'])) {
                $updates[] = "date_expiration = ?";
                $params[] = $_POST['date_expiration'];
                $types .= 's';
            }
            if (!empty($_POST['photo'])) {
                $updates[] = "photo = ?";
                $params[] = $_POST['photo'];
                $types .= 's';
            }
            if (!empty($_POST['etat'])) {
                $updates[] = "etat = ?";
                $params[] = $_POST['etat'];
                $types .= 's';
            }

            // Ajouter l'ID à la fin des paramètres
            $params[] = $id;
            $types .= 'i';

            // Si des champs sont à mettre à jour
            if (!empty($updates)) {
                // Construire la requête SQL dynamique
                $sql_update = "UPDATE users SET " . implode(", ", $updates) . " WHERE id = ?";

                // Préparer et exécuter la requête
                $stmt_update = $conn->prepare($sql_update);
                $stmt_update->bind_param($types, ...$params); // '...' décompose le tableau $params en arguments individuels

                if ($stmt_update->execute()) {
                    echo json_encode(['status' => 'success', 'message' => 'Utilisateur mis à jour avec succès']);
                } else {
                    echo json_encode(['status' => 'error', 'message' => 'Erreur lors de la mise à jour de l\'utilisateur']);
                }
                $stmt_update->close();
            } else {
                echo json_encode(['status' => 'error', 'message' => 'Aucun champ à mettre à jour']);
            }
        }
        $stmt_check_id->close();
    }

    // SUPPRIMER un utilisateur
    elseif ($action == 'supprimer' && !empty($id)) {
        // Vérifier si l'ID existe avant de supprimer
        $sql_check_id = "SELECT * FROM users WHERE id = ?";
        $stmt_check_id = $conn->prepare($sql_check_id);
        $stmt_check_id->bind_param("i", $id);
        $stmt_check_id->execute();
        $result_check_id = $stmt_check_id->get_result();

        if ($result_check_id->num_rows == 0) {
            // Si l'ID n'existe pas, envoyer un message d'erreur
            echo json_encode(['status' => 'error', 'message' => 'ID n\'existe pas']);
        } else {
            // Supprimer l'utilisateur en fonction de l'ID
            $sql_delete = "DELETE FROM users WHERE id = ?";
            $stmt_delete = $conn->prepare($sql_delete);
            $stmt_delete->bind_param("i", $id);

            if ($stmt_delete->execute()) {
                echo json_encode(['status' => 'success', 'message' => 'Utilisateur supprimé avec succès']);
            } else {
                echo json_encode(['status' => 'error', 'message' => 'Erreur lors de la suppression de l\'utilisateur']);
            }
            $stmt_delete->close();
        }
        $stmt_check_id->close();
    }

    // Action non valide
    else {
        echo json_encode(['status' => 'error', 'message' => 'Action non valide ou ID manquant']);
    }
}

$conn->close();
?>
